#include "osdsh.h"
#include "../config.h"
#include <apm.h>
    settings_t apmset;
    xosd *apmosd;

/*=============================apm_watch()=========================== */
/* some ideas from apmd's "apm" utility*/
void *apm_watch(void *arg)
{
    int secs;
    apm_info i;
    char battery[255];
    char remainingtime[255];
    char report1[255];

	apmosd =
	    xosd_init(apmset.font, apmset.color, apmset.delay,
		apmset.xposition, apmset.yposition,
		apmset.soffset, apmset.xoffset, apmset.yoffset);


    while(apmset.display) {
	    if (apm_read(&i))
	    {
		fprintf(stderr, "Cannot read APM information\n");
		apmset.display = 0;
	    }
	    secs = i.using_minutes ? i.battery_time * 60 : i.battery_time;
            if (i.battery_flags != 0xff	/* Have a 1.1 BIOS and a system battery. */
		&& i.battery_flags & 0x80) {
		sprintf(battery, "no system battery");
	    }
	    else {
		switch (i.battery_status) {
		case 0:
	    	    sprintf(battery, "high");
		    xosd_set_colour(apmosd, apmset.color);
		    xosd_set_timeout(apmosd, apmset.delay);
	    	break;
		case 1:
	    	    sprintf(battery, "low");
		    xosd_set_colour(apmosd, "yellow");
		    xosd_set_timeout(apmosd, apmset.delay);
	    	break;
		case 2:
	    	    sprintf(battery, "critical!!");
		    xosd_set_colour(apmosd, "red");
		    xosd_set_timeout(apmosd, apmset.delay/2);
	    	break;
		case 3:
	    	    sprintf(battery, "charging...");
		    xosd_set_timeout(apmosd, apmset.delay);	
	    	break;
	        }

	    }
	    if (strcmp(battery, "no system battery")==0) {
		xosd_display(apmosd, apmset.yposition==XOSD_bottom?1:0, XOSD_string,
			"AC on line");
		xosd_display(apmosd, apmset.yposition==XOSD_bottom?0:1, XOSD_string, battery);
	    }
	    else {
		sprintf(remainingtime, "%dhr, %dmin, %dsec",
				secs/3600,
				(secs%3600)/60,
				((secs%3600)%60)%60);
		sprintf(report1, "AC: %s Remaining battery: %d%%(%s) %s",
			i.ac_line_status?"on line":"off line",i.battery_percentage, remainingtime, battery);


		xosd_display(apmosd, 0, XOSD_string, report1);
		xosd_display(apmosd, 1, XOSD_percentage,
				i.battery_percentage );
	    }}
    pthread_exit(0);
}
